<script>
/*****************************************************************
// IBM Confidential
// OCO Source Material
// 5724-W78
// (C) Copyright IBM Corp. 2011
// The source code for this program is not published or otherwise
// divested of its trade secrets, irrespective of what has been
// deposited with the U. S. Copyright Office.
 *****************************************************************
 */
 
 //This check can be passed as an argument to secure functions
//in the API that you call or any secure functions you define in
//secureUserExtensions.js
var userSecurityCheck = new Function('return window');

function launchpadStop() {
    top.logEnter("ENTER launchpadStop", []);

    top.logExit("EXIT launchpadStop", []);
    top.Exit();
}


function setMediaFolderCookie(mediaFolder, cookieName) {
    top.logEnter("ENTER setMediaFolderCookie", [mediaFolder, cookieName]);

    var cookieValue = getCookie(cookieName);
    eval(mediaFolder+"=cookieValue");
    top.logDebug("Store location for installation files: '"+mediaFolder+"'='"+cookieValue+"'");
    if (cookieValue == undefined || cookieValue.length <= 0) {
        eval(mediaFolder+"=top.STARTINGDIR");
        setCookie(cookieName,top.STARTINGDIR,30);
    }

    top.logExit("EXIT setMediaFolderCookie", []);
}

function setVariableFromCookieBoolean(cookieName, variable) {
    top.logEnter("ENTER setVariableFromCookieBoolean", [cookieName, variable]);

    var cookieContent = getCookie(cookieName);
    if (cookieContent != undefined && cookieContent.length > 0) {
        newValue = convertStringToBoolean(cookieContent);
        eval(variable+"="+newValue);
    }

    top.logExit("EXIT setVariableFromCookieBoolean", []);
}

function setCookieAndVariableBoolean(cookieName, variable, newValue) {
    top.logEnter("ENTER setCookieAndVariableBoolean", [cookieName, variable, newValue]);

    var valueToSet = "false";
    if (newValue) {
        valueToSet = "true";
    }

    eval(variable+"="+newValue);

    setCookie(cookieName,valueToSet,30);

    top.logExit("EXIT setCookieAndVariableBoolean", []);
}

 /**************************************************************************
 * INITIALIZE LAUNCHPAD AND ITS VARIABLES
 */

top.isServerRoleManagement = false
top.isServerRoleAdmin = false

function initInstallationVariables() {
    top.logEnter("ENTER initInstallationVariables", []);

    top.userRootLabel = getCookieDefault("UserRootValue", "root");
    top.pwRootLabel = ""; // To initialize/instantiate such variable (not allowed to store in a cookie)
    top.userDB2Label = getCookieDefault("UserDB2Value", "ctginst1");
    top.serverDB2Label = getCookieDefault("ServerDB2Value", "localhost");
    top.portDB2Label = getCookieDefault("PortDB2Value", "50005");
    top.dbnameDB2MaximoLabel = getCookieDefault("DBnameDB2MaximoValue", "MAXDB71");
    top.schemanameDB2MaximoLabel = getCookieDefault("SchemanameDB2MaximoValue", "maximo");
    top.userDB2MaximoLabel = getCookieDefault("UserDB2MaximoValue", "maximo");
    top.pwDB2MaximoLabel = ""; // To initialize/instantiate such variable (not allowed to store in a cookie)
    top.userLDAPLabel = getCookieDefault("UserLDAPValue", "cn=root");
    top.pwLDAPLabel = ""; // To initialize/instantiate such variable (not allowed to store in a cookie)
    top.serverLDAPLabel = getCookieDefault("ServerLDAPValue", "localhost");
    top.portLDAPLabel = getCookieDefault("PortLDAPValue", "389");
    top.homeIHSLabel = getCookieDefault("HomeIHSValue", ((isAIX())?"/usr":"/opt")+"/IBM/HTTPServer");
    top.homeWASLabel = getCookieDefault("HomeWASValue", ((isAIX())?"/usr":"/opt")+"/IBM/WebSphere/AppServer");
    top.profileWASLabel = getCookieDefault("ProfileWASValue", "ctgAppSrv01");
    top.cellWASLabel = getCookieDefault("CellWASValue", "ctgCell01");
    top.cellManagerWASLabel = getCookieDefault("CellManagerWASValue", "ctgCellManager01");
    top.nodeWASLabel = getCookieDefault("NodeWASValue", "ctgNode01");
    top.asWASLabel = getCookieDefault("AsWASValue", "MXServer");
    top.asWebserverLabel = getCookieDefault("AsWebserverValue", "webserver1");
    top.asPortWASLabel = getCookieDefault("AsPortWASValue", "9443");
    top.userWASLabel = getCookieDefault("UserWASValue", "wasadmin");
    top.pwWASLabel = ""; // To initialize/instantiate such variable (not allowed to store in a cookie)
    top.pwSSHLabel = ""; // To initialize/instantiate such variable (not allowed to store in a cookie)
    top.userBaseLabel = getCookieDefault("UserBaseValue", "maxadmin");
    top.pwBaseLabel = ""; // To initialize/instantiate such variable (not allowed to store in a cookie)
    top.serverTPMLabel = getCookieDefault("ServerTPMValue", "");
    top.userTIOLabel = getCookieDefault("UserTIOValue", "tioadmin");
    top.pwAgenManagerLabel = ""; // To initialize/instantiate such variable (not allowed to store in a cookie)
    top.serverMailLabel = getCookieDefault("ServerMailLabel", "localhost");
    top.serverMaximoLabel = getCookieDefault("ServerMaximoLabel", "localhost");
    top.emailMailLabel = getCookieDefault("EmailMailLabel", "root@localhost");
    top.homeTPAeLabel = getCookieDefault("HomeTPAeValue", ((isWindows())?"C:\\IBM\\SMP":"/opt/IBM/SMP"));

    top.logExit("EXIT initInstallationVariables", []);
}

function setInstallationVariables2Cookies() {
    top.logEnter("ENTER setInstallationVariables2Cookies", []);

    setCookie("UserRootValue", top.userRootLabel, 30);
    setCookie("UserDB2Value", top.userDB2Label, 30);
    setCookie("UserDB2MaximoValue", top.userDB2MaximoLabel, 30);
    setCookie("ServerDB2Value", top.serverDB2Label, 30);
    setCookie("PortDB2Value", top.portDB2Label, 30);
    setCookie("DBnameDB2MaximoValue", top.dbnameDB2MaximoLabel, 30);
    setCookie("SchemanameDB2MaximoValue", top.schemanameDB2MaximoLabel, 30);
    setCookie("UserLDAPValue", top.userLDAPLabel, 30);
    setCookie("ServerLDAPValue", top.serverLDAPLabel, 30);
    setCookie("PortLDAPValue", top.portLDAPLabel, 30);
    setCookie("HomeIHSValue", top.homeIHSLabel, 30);
    setCookie("HomeWASValue", top.homeWASLabel, 30);
    setCookie("ProfileWASValue", top.profileWASLabel, 30);
    setCookie("CellWASValue", top.cellWASLabel, 30);
    setCookie("CellManagerWASValue", top.cellManagerWASLabel, 30);
    setCookie("NodeWASValue", top.nodeWASLabel, 30);
    setCookie("AsWASValue", top.asWASLabel, 30);
    setCookie("AsWebserverValue", top.asWebserverLabel, 30);
    setCookie("AsPortWASValue", top.asPortWASLabel, 30);
    setCookie("UserWASValue", top.userWASLabel, 30);
    setCookie("UserBaseValue", top.userBaseLabel, 30);
    setCookie("ServerTPMValue", top.serverTPMLabel, 30);
    setCookie("UserTIOValue", top.userTIOLabel, 30);
    setCookie("HomeTPAeValue", top.homeTPAeLabel, 30);

    top.logExit("EXIT setInstallationVariables2Cookies", []);
}

function initLogFilterForDebug() {
    top.logEnter("ENTER initLogFilterForDebug", []);

    if (isTestEnvVar("DEBUG_TSAM_LAUNCHPAD")) {
        top.logSetFilter("CESWTD");
    } else {
        top.logSetFilter("ESWD");
    }

    top.logExit("EXIT initLogFilterForDebug", []);
}

function initVariablesFromCookies() {
    top.logEnter("ENTER initVariablesFromCookies", []);

    setVariableFromCookieBoolean("ServerRoleManagement", "top.isServerRoleManagement");
    setVariableFromCookieBoolean("ServerRoleAdmin", "top.isServerRoleAdmin");

    top.logExit("EXIT initVariablesFromCookies", []);
}

function initVariables() {
    top.logEnter("ENTER initVariables", []);

    initVariablesFromCookies();

    initInstallationVariables();

	initMediaFolderDataFromCookie();
	
	initPrerequesiteDataFromCookie();

    top.logExit("EXIT initVariables", []);
}

function promptUserForLaunchpadRootDirectory(numberOfRetries) 
{
    top.logEnter("ENTER promptUserForLaunchpadRootDirectory", [numberOfRetries]);

    var count=0;
    while (getEnv("lpRoot") == "") {
        count++;
        // NOTE: the following cannot be NLS because properties cannot be used if launchpad root is not found
        var userDir = prompt("Unable to determine path", "Please enter the path to the launchpad image");
        if (directoryExists(NO_DISKID,userDir+"\launchpad")) {
            setEnvironmentVariable("lpRoot",userDir, false);
        } else {
            if (count == numberOfRetries) {
                alert("Can't locate source directory for installation media.  Click OK to exit.");
                top.Exit()
            }
        }
    }

    top.logExit("EXIT promptUserForLaunchpadRootDirectory", []);
}

function initLaunchpadRootDirectory() 
{
    top.logEnter("ENTER initLaunchpadRootDirectory", []);

    var topLevel = top.STARTINGDIR;

    if (directoryExists(NO_DISKID,topLevel+"launchpad")) {
        setEnvironmentVariable("lpRoot",top.MediaDataArray[top.Enum.MediaDataType.tsam].currentPath, false);
    } else {
        promptUserForLaunchpadRootDirectory(3);
    }

    top.logExit("EXIT initLaunchpadRootDirectory", []);
}

function initCookieFile() 
{
    top.logEnter("ENTER initCookieFile", []);

    if (isUnix()) {
        top.cookieFile = getEnv("HOME") + "/.cookies.txt";
    	if ( isTestEnvVar("TEST_LINUX") && (top.OSTYPE.toUpperCase() == 'WINDOWS') ){
    		// SIMULATED Linux under Windows! We use the users home directory instead
	        top.cookieFile = getEnv("HOMEDRIVE") + getEnv("HOMEPATH") + "\\TSAM_LP_cookies.txt";
    	}
    }

    top.logExit("EXIT initCookieFile", [top.cookieFile]);
}

function launchpadStartup() 
{
    initLogFilterForDebug();
    
    top.logEnter("ENTER launchpadStartup", []);
    logVersionInfo();
    
    initCookieFile();
    initVariables();
    initLaunchpadRootDirectory();
    
    top.logExit("EXIT launchpadStartup", []);
}

function logVersionInfo(){
	var fileName = top.combinePathAndFilename(top.STARTINGDIR, property('versionInfoFile'));
	if ( top.fileExists(fileName) ){
		var versionInfo = top.readTextFile(fileName);
		top.logDebug("- VERSION INFO ... -");
		top.logDebug(versionInfo);
		top.logDebug("- ... VERSION INFO -");
	}
	else {
		top.logDebug("- NO VERSION INFO AVAILABLE -");
	}
}


</script>